:- use_module('tclp.pl').
:- use_module(tclp__errors).
:- use_module(tclpext__type_graph).
:- use_module(library(system)).

load_with_dir(Dir) :-
        catch((
               tclp__reinit(tclp__add_search_directory(Dir)),
               tclp__set_inference(true), tclp__set_functor_labeling(true)),
             Exception,
              (
                print_exception(Exception);
                write('! Failed'),nl,fail
              )).

loadiso :-
        load_with_dir('../lib/ISO').

loadsics :-
        catch((
               tclp__reinit((tclp__add_search_directory('../lib/sicstus'),
                            enable_sicstus)),
               tclp__set_inference(true), tclp__set_functor_labeling(true)),
             Exception,
              (
                print_exception(Exception);
                write('! Failed'),nl,fail
              )).

loadgnu :-
        load_with_dir('../lib/gprolog').

test :-
        catch((tclp('../test/simple.pl')),
             Exception,
              (
                print_exception(Exception);
                write('! Failed'),nl,fail
              )).

loadsicslibs :-
        catch((
               directory_files('../lib/sicstus',Files),
               findall(F,(member(F,Files),atom_concat(_,'.typ',F),
                          \+ (
                               atom_concat(_,'stdlib.typ',F);
                               atom_concat(_,'corelib.typ',F)
                             )),
                       ToLoad),
               tclp(ToLoad)
              ),
              Exception,
              (
                print_exception(Exception);
                write('! Failed'),nl,fail
              )).
